"""
 Princeton University, COS 429, Fall 2020
"""
import os
from glob import glob
import numpy as np


def get_testing_data(n, orientations, wrap180):
    """Reads in examples of faces and nonfaces, and builds a matrix of HoG
       descriptors, ready to pass in to logistic_predict

    Args:
        n: number of face and nonface testing examples (n of each)
        orientations: the number of HoG gradient orientations to use
        wrap180: if true, the HoG orientations cover 180 degrees, else 360

    Returns:
        descriptors: matrix of descriptors for all 2*n testing examples, where
                     each row contains the HoG descriptor for one face or nonface
        classes: vector indicating whether each example is a face (1) or nonface (0)
    """
    testing_faces_dir = 'face_data/testing_faces'
    testing_nonfaces_dir = 'face_data/testing_nonfaces'
    hog_input_size = 36
    hog_descriptor_size = 100 * orientations

    # Get the names of the first n testing faces
    face_filenames = sorted(glob(os.path.join(testing_faces_dir, '*.jpg')))
    num_face_filenames = len(face_filenames)
    if num_face_filenames > n:
        face_filenames = face_filenames[:n]
    elif num_face_filenames < n:
        n = num_face_filenames

    # Initialize descriptors, classes
    descriptors = np.zeros([2 * n, hog_descriptor_size + 1])
    classes = np.zeros([2 * n])

    # Loop over faces
    for i in range(n):
        # Fill in here

    # Loop over nonfaces
    nonface_filenames = sorted(glob(os.path.join(testing_nonfaces_dir, '*.jpg')))
    for i in range(n, 2 * n):
        # Fill in here
        # Note that unlike in get_training_data, you are not sampling
        # random patches from the nonface images, just reading them in
        # and using them directly.

    return descriptors, classes
